function [xmin, fmin, func_eval, func_near, std, fmin_conv] = abc(fn_name, D, a, b, N, limit, max_evals, myeps, shift, f_near)
%vystup:
%xmin = souadnice nalezenho een
%fmin = funkn hodnota nalezenho een
%func_evals = poet evaluac funkce
%func_near = evaluac kdy se pekroilo f_near
%std = pole smrodatnch odchylek v 10 etapch 
%fmin_conv = vvoj nalezenho minima, 1 inicializace, 10 max evaluac

%vstup:
%D= dimenze proh. prostoru
%limit = poet neuspnch pokusu o zlepen kdy se aktivuje scout
%a, b = spodn a horn hranice prohledvanho prostoru
%N = velikost populace
% myeps = ukon. podmnka kdy je populace blzko u sebe 
% max_evals = max evaluac
%f_near = podmnka pro func_near

Range = repmat((b-a),[N 1]);
Lower = repmat(a, [N 1]);
P = rand(N, D) .* Range + Lower;
for i = 1:N
    P(i, D + 1) = feval(fn_name, P(i, 1:D) - shift);
end
P(:, D + 2) = calculateFitness(P(:, D + 1));
%reset trial counters
P(:, D + 3) = zeros(1, N);
%/*The best food source is memorized*/
BestInd = find(P(:, D + 1) == min(P(:, D + 1)));
BestInd = BestInd(end);
fmin = P(BestInd, D + 1);
fmax = max(P(:, D + 1));
xmin=P(BestInd, 1:D);
func_eval = N;
func_near = 0;

%ukladani prubehu vypoctu
FES_lim = zeros(10, 1);
for i = 2:10
    l = i-1;
    FES_lim(i) = l * 0.1 * max_evals;
end
fmin_conv = NaN(10,1);
std = NaN(10,1);
etapa = 1;

% initial population done
while ((func_eval < max_evals)) && (fmin > 1e-8) && (fmax - fmin > myeps)
    %%%%%%%%% EMPLOYED BEE PHASE %%%%%%%%%%%%%%%%%%%%%%%%
    for i=1:N
        %/*The parameter to be changed is determined randomly*/
        Param2Change = fix(rand * D) + 1;
        %/*A randomly chosen solution is used in producing a mutant solution of the solution i*/
        neighbour = fix(rand * N) + 1;
        %/*Randomly selected solution must be different from the solution i*/
        while(neighbour == i)
            neighbour = fix(rand * N ) + 1;
        end;
        sol = P(i, 1:D);
        %  /*v_{ij}=x_{ij}+\phi_{ij}*(x_{kj}-x_{ij}) */
        sol(Param2Change) = P(i, Param2Change) + (P(i, Param2Change) - P(neighbour, Param2Change)) * (rand - 0.5) * 2;
        %  /*if generated parameter value is out of boundaries, it is shifted onto the boundaries*/
        ind = find(sol < a);
        sol(ind) = a(ind);
        ind = find(sol > b);
        sol(ind) = b(ind);
        %evaluate new solution
        ObjValSol = feval(fn_name, sol - shift);
        FitnessSol = calculateFitness(ObjValSol);
        % /*a greedy selection is applied between the current solution i and its mutant*/
        if (FitnessSol > P(i, D + 2)) %/*If the mutant solution is better than the current solution i, replace the solution with the mutant and reset the trial counter of solution i*/
            P(i, 1:D) = sol;
            P(i, D + 2) = FitnessSol;
            P(i, D + 1) = ObjValSol;
            P(i, D + 3) = 0;
        else
            P(i, D + 3) = P(i, D + 3) + 1; %/*if the solution i can not be improved, increase its trial counter*/
        end;
    end;
    func_eval = func_eval + N;
    
    if func_near == 0 && fmin < f_near
        func_near = func_eval;
    end    
    
    %%%%%%%%%%%%%%%%%%%%%%%% CalculateProbabilities %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %/* A food source is chosen with the probability which is proportioal to its quality*/
    %/*Different schemes can be used to calculate the probability values*/
    %/*For example prob(i)=fitness(i)/sum(fitness)*/
    %/*or in a way used in the metot below prob(i)=a*fitness(i)/max(fitness)+b*/
    %/*probability values are calculated by using fitness values and normalized by dividing maximum fitness value*/
    prob = (0.9 .* P(:, D + 2) ./ max(P(:, D + 2))) + 0.1;
    %%%%%%%%%%%%%%%%%%%%%%%% ONLOOKER BEE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    i = 1;
    t = 0;
    while(t < N)
        if(rand < prob(i))
            t = t + 1;
            %/*The parameter to be changed is determined randomly*/
            Param2Change = fix(rand * D) + 1;
            %/*A randomly chosen solution is used in producing a mutant solution of the solution i*/
            neighbour = fix(rand * N) + 1;
            %/*Randomly selected solution must be different from the solution i*/
            while(neighbour == i)
                neighbour = fix(rand * N) + 1;
            end;
            sol = P(i, 1:D);
            %  /*v_{ij}=x_{ij}+\phi_{ij}*(x_{kj}-x_{ij}) */
            sol(Param2Change) = P(i, Param2Change) + (P(i, Param2Change) - P(neighbour, Param2Change)) * (rand - 0.5) * 2;
            %  /*if generated parameter value is out of boundaries, it is shifted onto the boundaries*/
            ind = find(sol < a);
            sol(ind) = a(ind);
            ind = find(sol > b);
            sol(ind) = b(ind);
            %evaluate new solution
            ObjValSol = feval(fn_name, sol - shift);
            func_eval = func_eval + 1;
            FitnessSol = calculateFitness(ObjValSol);
            % /*a greedy selection is applied between the current solution i and its mutant*/
            if (FitnessSol > P(i, D + 2)) %/*If the mutant solution is better than the current solution i, replace the solution with the mutant and reset the trial counter of solution i*/
                P(i, 1:D) = sol;
                P(i, D + 2) = FitnessSol;
                P(i, D + 1) = ObjValSol;
                P(i, D + 3) = 0;
            else
                P(i, D + 3) = P(i, D + 3) + 1; %/*if the solution i can not be improved, increase its trial counter*/
            end;
        end;
        i = i + 1;
        if (i == (N + 1))
            i = 1;
        end;
    end;
    %/*The best food source is memorized*/
    ind = find(P(:, D + 1) == min(P(:, D + 1)));
    ind = ind(end);
    if (P(ind, D + 1) < fmin)
        fmin = P(ind, D + 1);
        fmax = max(P(:, D + 1));
        xmin = P(ind, 1:D);
    end;
    
    if(fmin < 1e-8)
       fmin = 1e-8; 
    end
        
    %vypocet sm odchylky a prubeh hledani
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    prum = mean(P(:,1:D)); %stred prostoru
    prum_mat = repmat(prum, N, 1); %sted maticov
    
    if etapa < 10 && isnan(fmin_conv(etapa)) && func_eval >= FES_lim(etapa)
        fmin_conv(etapa) = fmin;
        std(etapa) = sqrt(sum(sum((P(:, 1:D) - prum_mat).*(P(:,1:D) - prum_mat)))/N); %etapa = 1..10
        etapa = etapa + 1;
    end
       
        
    %%%%%%%%%%%% SCOUT BEE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %/*determine the food sources whose trial counter exceeds the "limit" value.
    %In Basic ABC, only one scout is allowed to occur in each cycle*/
    ind = find(P(:, D + 3) == max(P(:, D + 3)));
    ind = ind(end);
    if (P(ind, D + 3) > limit)
        P(ind, D + 3) = 0;
        sol = (b - a) .* rand(1, D) + a;
        ObjValSol = feval(fn_name, sol - shift);
        func_eval = func_eval + 1;
        FitnessSol = calculateFitness(ObjValSol);
        P(ind, 1:D) = sol;
        P(ind, D + 2) = FitnessSol;
        P(ind, D + 1) = ObjValSol;
        
    end;
    %fmin=ObjVal(ind)- fistar;
end % End of ABC