function [xmin, fnmin, func_evals, func_near, std, fmin_conv] =bat(fn_name, a, b, N, my_eps, max_evals, f_near, A, r, shift)

%vystup:
%xmin = souadnice nalezenho een
%fnmin = funkn hodnota nalezenho een
%func_evals = poet evaluac funkce
%func_near = evaluac kdy se pekroilo f_near
%std = pole smrodatnch odchylek v 10 etapch 
%fmin_conv = vvoj nalezenho minima, 1 inicializace, 10 max evaluac

%vstup:
%a, b = spodn a horn hranice prohledvanho prostoru
%N = velikost populace
% my_eps = ukon. podmnka kdy je populace blzko u sebe 
% max_evals = max evaluac
%f_near = podmnka pro func_near
%A, r =  parametry algoritmu, shift je posun 

% initialization
D = length(a);
func_near = 0;
f = zeros(N, 1);
Ai = f;
ri = Ai;

Qmin=0;        % Frequency minimum
Qmax=b(1); % Frequency maximum
if Qmax > 100
    Qmax = 100;
end
Q=zeros(N,1);  % Frequency
v=zeros(N,D);  % Velocities

%ukladani prubehu vypoctu
FES_lim = zeros(10, 1);
for i = 2:10
    l = i-1;
    FES_lim(i) = l * 0.1 * max_evals;
end
fmin_conv = NaN(10,1);
std = NaN(10,1);
etapa = 1;

for i = 1:N
    P(i, :) = a + (b - a) .* rand(1, D);
    f(i) = feval(fn_name, P(i, :) - shift);
    Ai(i) = A;
    ri(i) = r;
end  % 0-th generation initialized

[fmin, indmin] = min(f);
xmin = P(indmin, :);
fmax = max(f);
func_evals = N;
gen = 1;

%main loop
while (func_evals < max_evals) && (fmax-fmin) > my_eps && (fmin > 1e-8)
    for i = 1:N  %  new generation
        Q(i)=Qmin+(Qmax - Qmin)*rand;
        v(i,:)=v(i,:)+(P(i,:)-xmin)*Q(i);
        S(i,:)=P(i,:)+v(i,:);
        
        % Pulse rate
        if rand>ri(i)
          % The factor 0.001 limits the step sizes of random walks 
              S(i,:)=xmin+0.001*randn(1,D);
              %disp(ri(i));
        end
        
         S(i, :) = zrcad(S(i, :), a, b);     % perturbation
        
         % Evaluate new solutions
           Fnew=feval(fn_name, S(i, :) - shift);
     % Update if the solution improves, or not too loud
           if (Fnew<=f(i)) && (rand<Ai(i))
                P(i,:)=S(i,:);
                f(i)=Fnew;
                %%redukce
                Ai(i) = 0.95 * Ai(i);
                %zvyen
                ri(i) = r * (1-exp(-0.9*gen));
           end

          % Update the current best solution
          if Fnew<=fmin,
                xmin=S(i,:);
                fmin=Fnew;
          end
          
          gen = gen+1;
    end % end of generation
        
    func_evals = func_evals + N;
    fmax = max(f);
    
    if func_near == 0 && fmin < f_near
        func_near = func_evals;
    end
    
    if (fmin<1e-8)
       fmin=1e-8; 
    end
        
    %vypocet sm odchylky a prubeh hledani
    prum = mean(P(:,1:D)); %stred prostoru
    prum_mat = repmat(prum, N, 1); %sted maticov
    
    if etapa < 10 && isnan(fmin_conv(etapa)) && func_evals >= FES_lim(etapa)
        fmin_conv(etapa) = fmin;
        std(etapa) = sqrt(sum(sum((P(:, 1:D) - prum_mat).*(P(:,1:D) - prum_mat)))/N); %etapa = 1..10
        etapa = etapa + 1;
    end
end   % main loop - end
xmin = P(indmin, 1:D);
fnmin = fmin;
