function [x_star, fn_star, func_evals, func_near, std, fmin_conv] =dfo(fn_name, a, b, N, my_eps, max_evals, f_near, dt, shift)
%
% Tvrdik, Aug 2014
%
%vystup:
%x_star = souadnice nalezenho een
%fn_star = funkn hodnota nalezenho een
%func_evals = poet evaluac funkce
%func_near = evaluac kdy se pekroilo f_near
%std = pole smrodatnch odchylek v 10 etapch 
%fmin_conv = vvoj nalezenho minima, 1 inicializace, 10 max evaluac

%vstup:
%a, b = spodn a horn hranice prohledvanho prostoru
%N = velikost populace
% my_eps = ukon. podmnka kdy je populace blzko u sebe 
% max_evals = max evaluac
%f_near = podmnka pro func_near
%dt =  parametry algoritmu, shift je posun 

% initialization
D = length(a);
P = zeros(N, D);
Q = P;
func_near = 0;
f = zeros(N, 1);
nb = zeros(N, 1);

%ukladani prubehu vypoctu
FES_lim = zeros(10, 1);
for i = 2:10
    l = i-1;
    FES_lim(i) = l * 0.1 * max_evals;
end
fmin_conv = NaN(10,1);
std = NaN(10,1);
etapa = 1;

for i = 1:N
    P(i, :) = a + (b - a) .* rand(1, D);
    f(i) = feval(fn_name, P(i, :) - shift);
end  % 0-th generation initialized
func_evals = N;
fmax = max(f);
[fmin, indmin] = min(f);
while (fmin > 1e-8) && (func_evals < max_evals) && (fmax - fmin > my_eps) % main loop
    [~, indmin] = min(f);
    best = P(indmin, :);  % swarm best
    for i = 2:N - 1  %  in each generation
        [~, indminnb] = min([f(i - 1), f(i + 1)]); %[~, indminnb] = min([f(i - 1), f(i), f(i + 1)]);
        nb(i) = indminnb;
    end
    [~, indminnb] = min([f(N), f(2)]);  %[~, indminnb] = min([f(N), f(1), f(2)]);
    nb(1) = indminnb;
    [~, indminnb] = min([f(N - 1), f(1)]); %[~, indminnb] = min([f(N - 1), f(N), f(1)]);
    nb(N) = indminnb;
    for i = 1:N  %  new generation
        Q(i, :) = P(nb(i), :) + rand(1, D) .* (best - P(i, :));
        Q(i, :) = zrcad(Q(i, :), a, b);     % perturbation
    end % end of generation
    %%%  dispersion
    QQ = Q(:);
    Rmat = rand(N * D, 1);
    mutuj = find(Rmat < dt);
    for i = mutuj       
        % QQ(i) = a(1)+(b(1)-a(1)).*rand(1,1); % Rmat(i,1);
        QQ(i) = a(1) + (b(1) - a(1)) * Rmat(i);  
    end    
    
    % size(QQ)
    Q = reshape(QQ, N, D);
    for i = 1:N
        f(i) = feval(fn_name, Q(i, :) - shift);
    end
    func_evals = func_evals + N;
    P = Q;
    fmax = max(f);
    [fmin, indmin] = min(f);
    if func_near == 0 && fmin < f_near
        func_near = func_evals;
    end
    
    if(fmin < 1e-8)
       fmin = 1e-8; 
    end
    
    %vypocet sm odchylky a prubeh hledani
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    prum = mean(P(:,1:D)); %stred prostoru
    prum_mat = repmat(prum, N, 1); %sted maticov
    
    if etapa < 10 && isnan(fmin_conv(etapa)) && func_evals >= FES_lim(etapa)
        fmin_conv(etapa) = fmin;
        std(etapa) = sqrt(sum(sum((P(:, 1:D) - prum_mat).*(P(:,1:D) - prum_mat)))/N); %etapa = 1..10
        etapa = etapa + 1;
    end
    
end   % main loop - end
x_star = P(indmin, 1:D);
fn_star = fmin;
%