function [xmin, fmin, func_evals, evals_near, std, fmin_conv] = pso(fn_name, a, b, N, my_eps, max_evals, fnear, shift, fi1, fi2, k)
%vystup:
%xmin = souadnice nalezenho een
%fmin = funkn hodnota nalezenho een
%func_evals = poet evaluac funkce
%func_near = evaluac kdy se pekroilo f_near
%std = pole smrodatnch odchylek v 10 etapch 
%fmin_conv = vvoj nalezenho minima, 1 inicializace, 10 max evaluac

%vstup:
%a, b = spodn a horn hranice prohledvanho prostoru
%N = velikost populace
% my_eps = ukon. podmnka kdy je populace blzko u sebe 
% max_evals = max evaluac
%fnear = podmnka pro func_near
%fi1, fi2, =  parametry algoritmu, shift je posun
%k = poet skupin

%Parametry:
D = length(a);
kappa = 1;  

%ukladani prubehu vypoctu
FES_lim = zeros(10, 1);
for i = 2:10
    l = i-1;
    FES_lim(i) = l * 0.1 * max_evals;
end

fmin_conv = NaN(10,1);
std = NaN(10,1);
etapa = 1;

%Algoritmus:
pocet_skupin=fix(N/k);
% skupiny velikosti k, posledni skupina muze byt vetsi
prislusnost=zeros(N,1);
for ii=1:pocet_skupin-1
skup=ii+ zeros(k,1);
prislusnost((ii-1)*k +1:(ii-1)*k+k) = skup;
end

prislusnost((pocet_skupin-1)*k +1:end) = pocet_skupin;
P=zeros(N,D+1);
v=zeros(N,D);
vmax=(b-a)/6; % pro generovani pocatecnich rychlosti

for i=1:N
P(i,1:D)=a+(b-a).*rand(1,D);
P(i,D+1)=feval(fn_name,P(i,1:D)-shift);
v(i,:)= -vmax + 2*vmax.*rand(1,D);
end % inicializace 0t generace

pbest=P; % nejlepsi pozice jedincu na pocatku = pocatecni pozice
lbest=zeros(pocet_skupin,D+1);

for ii=1:pocet_skupin
ind_skup= prislusnost==ii;
pom=P(ind_skup,:);
[tmp, ind_lmin]=min(pom(:,D+1));
lbest(ii,:)=pom(ind_lmin,:);
end
fmax=max(P(:,D+1));
fmin=min(P(:,D+1));
func_evals=N; evals_near=0;
fi=fi1+fi2;
chi=2*kappa / (fi-2+sqrt(fi*(fi-4)));
% chi je koef. sevreni (constriction coeff.)

while (fmin > 1e-8) && (func_evals < max_evals) && (fmax-fmin > my_eps)
for i=1:N % v kad generaci
x=P(i,1:D); % pozice i-teho jedince
v(i,:)=chi*(v(i,:)+fi1*rand(1,D).*(pbest(i,1:D)-x)...
+fi2*rand(1,D).*(lbest(prislusnost(i),1:D)-x));
y = x + v(i,:); % nova pozice
y=zrcad(y,a,b); % zabranuje opustit definicni obor
fy=feval(fn_name,y-shift);
P(i,:)=[y,fy]; % zapis novou pozici a funkcni hodnotu
func_evals=func_evals+1;
if fy < pbest(i,D+1) % aktualizace pbest
pbest(i,:)= [y,fy];
% prepis pozici a funkcni hodnotu pbest
end
if fy < lbest(prislusnost(i),(D+1)) % aktualizace gbest
lbest(prislusnost(i),:)=[y, fy];
end
end % end of generation
fmax=max(P(:,D+1));
fmin=min(P(:,D+1));
if evals_near==0 && fmin<fnear
evals_near=func_evals;
end

if(fmin < 1e-8)
       fmin = 1e-8; 
end
        
    %vypocet sm odchylky a prubeh hledani
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    prum = mean(P(:,1:D)); %stred prostoru
    prum_mat = repmat(prum, N, 1); %sted maticov
    
    if etapa < 10 && isnan(fmin_conv(etapa)) && func_evals >= FES_lim(etapa)
        fmin_conv(etapa) = fmin;
        std(etapa) = sqrt(sum(sum((P(:, 1:D) - prum_mat).*(P(:,1:D) - prum_mat)))/N); %etapa = 1..10
        etapa = etapa + 1;
    end

end % main loop - end

[fmin, indmin]=min(P(:,D+1));
xmin=P(indmin,1:D);

if(fmin < 1e-8)
       fmin = 1e-8; 
end

end

